replace dos2unix with sed 's/\r//g'
[nofib.git] / runstdtest / runstdtest.prl
1 #
2 # The perl script requires the following variables to be bound
3 # to something meaningful before it will operate correctly:
4 #   
5 #   DEFAULT_TMPDIR
6 #   CONTEXT_DIFF
7 #   RM
8 #
9 # Given:
10 #       * a program to run (1st arg)
11 #       * some "command-line opts" ( -O<opt1> -O<opt2> ... )
12 #           [default: anything on the cmd line this script doesn't recognise ]
13 #         the first opt not starting w/ "-" is taken to be an input
14 #         file and (if it exists) is grepped for "what's going on here"
15 #         comments (^-- !!!).
16 #       * a file to feed to stdin ( -i<file> ) [default: /dev/null ]
17 #       * a "time" command to use (-t <cmd>).
18 #
19 #       * alternatively, a "-script <script>" argument says: run the
20 #         named Bourne-shell script to do the test.  It's passed the
21 #         pgm-to-run as the one-and-only arg.
22 #
23 # Run the program with those options and that input, and check:
24 # if we get...
25
26 #       * an expected exit status ( -x <val> ) [ default 0 ]
27 #       * expected output on stdout ( -o1 <file> ) [ default /dev/null ]
28 #               ( we'll accept one of several...)
29 #       * expected output on stderr ( -o2 <file> ) [ default /dev/null ]
30 #               ( we'll accept one of several...)
31 #
32 #       (if the expected-output files' names end in .Z, then
33 #        they are uncompressed before doing the comparison)
34
35 # (This is supposed to be a "prettier" replacement for runstdtest.)
36 #
37 #       Flags
38 #       ~~~~~
39 #       -accept-output  replace output files with the ones actually generated by running
40 #                       the program
41 #
42 ($Pgm = $0) =~ s|.*/||;
43 $Verbose = 0;
44 $SaveStderr = 0;
45 $SaveStdout = 0;
46 $StdoutBinary = 0;
47 $StderrBinary = 0;
48 $Status = 0;
49 @PgmArgs = ();
50 $PgmFail=0;
51 $PgmExitStatus = 0;
52 $PgmStdinFile  = '/dev/null';
53 if ( $ENV{'TMPDIR'} ) { # where to make tmp file names
54     $TmpPrefix = $ENV{'TMPDIR'};
55 } else {
56     $TmpPrefix ="$DEFAULT_TMPDIR";
57     $ENV{'TMPDIR'} = "$DEFAULT_TMPDIR"; # set the env var as well
58 }
59 # If this is Cygwin, ignore eol and CR characters.
60 # Perhaps required for MSYS too, although the cygpath
61 # bit is hopefully unnecessary.
62 if ( `uname | grep CYGWIN` ) {
63     $CONTEXT_DIFF=$CONTEXT_DIFF . " --strip-trailing-cr" ;
64     $TmpPrefix = `cygpath -m $TmpPrefix | tr -d \\\\n`;
65 }
66 $ScriptFile = "$TmpPrefix/run_me$$";
67 $DefaultStdoutFile = "$TmpPrefix/no_stdout$$"; # can't use /dev/null (e.g. Alphas)
68 $DefaultStderrFile = "$TmpPrefix/no_stderr$$";
69 @PgmStdoutFile = ();
70 @PgmStderrFile = ();
71 $PreScript = '';
72 $PostScript = '';
73 $TimeCmd = 'time';
74 $StatsFile = "$TmpPrefix/stats$$";
75 $CachegrindStats = "cachegrind.out.summary";
76 $SysSpecificTiming = '';
77 $SysCPUCounting = 0; # Use CPU counters
78 $Cachegrind = 'no';
79 $Counters = "";
80
81 die "$Pgm: program to run not given as first argument\n" if $#ARGV < 0;
82 $ToRun = $ARGV[0]; shift(@ARGV);
83 # avoid picking up same-named thing from somewhere else on $PATH...
84 $ToRun = "./$ToRun" if -e "./$ToRun";
85
86 arg: while ($_ = $ARGV[0]) {
87     shift(@ARGV);
88     
89     /^--$/      && do { # let anything past after --
90                         push(@PgmArgs, @ARGV);
91                         last arg; };
92
93     /^-v$/             && do { $Verbose = 1; next arg; };
94     /^-accept-output-stderr$/ && do { $SaveStderr = 1; next arg; };
95     /^-accept-output-stdout$/ && do { $SaveStdout = 1; next arg; };
96     /^-accept-output$/        && do { $SaveStdout = 1; $SaveStderr = 1; next arg; };
97
98     /^-stdout-binary/ && do { $StdoutBinary=1; next arg; };
99     /^-stderr-binary/ && do { $StderrBinary=1; next arg; };
100
101     /^-O(.*)/   && do { push(@PgmArgs, &grab_arg_arg('-O',$1)); next arg; };
102     /^-i(.*)/   && do { $PgmStdinFile = &grab_arg_arg('-i',$1);
103                         $Status++,
104                         print STDERR "$Pgm: bogus -i input file: $PgmStdinFile\n"
105                             if $PgmStdinFile !~ /^\/dev\/.*$/ && ! -f $PgmStdinFile;
106                         next arg; };
107     /^-fail/    && do { $PgmFail=1; next arg; };
108     /^-x(.*)/   && do { $PgmExitStatus = &grab_arg_arg('-x',$1);
109                         $Status++ ,
110                         print STDERR "$Pgm: bogus -x expected exit status: $PgmExitStatus\n"
111                             if $PgmExitStatus !~ /^\d+$/;
112                         next arg; };
113     /^-o1(.*)/  && do { $out_file = &grab_arg_arg('-o1',$1);
114                         push(@PgmStdoutFile, $out_file);
115                         next arg; };
116     /^-o2(.*)/  && do { $out_file = &grab_arg_arg('-o2',$1);
117                         push(@PgmStderrFile, $out_file);
118                         next arg; };
119     /^-prescript(.*)/  && do { $PreScript = &grab_arg_arg('-prescript',$1);
120                                 next arg; };
121     /^-postscript(.*)/ && do { $PostScript = &grab_arg_arg('-postscript',$1);
122                                 next arg; };
123     /^-script/ && do { print STDERR "$Pgm: -script argument is obsolete;\nUse -prescript and -postscript instead.\n";
124                     $Status++;
125                     next arg; };
126     /^-(ghc|hbc)-timing$/ && do { $SysSpecificTiming = $1;
127                                   next arg; };
128     /^-cpu-counting-(.)$/ && do { $SysCPUCounting = "$1";
129                                   next arg; };
130     /^-cachegrind$/ && do { $SysSpecificTiming = 'ghc-instrs';
131                             $Cachegrind = 'yes'; 
132                             next arg };
133     /^-t(.*)/   && do { $TimeCmd = &grab_arg_arg('-t', $1); next arg; };
134
135     # anything else is taken to be a pgm arg
136     push(@PgmArgs, $_);
137 }
138
139 foreach $out_file ( @PgmStdoutFile ) {
140     if ( ! -f $out_file && !$SaveStdout ) {
141             print STDERR "$Pgm: warning: expected-stdout file missing: $out_file\n";
142             pop(@PgmStdoutFile);
143     }
144 }
145
146 foreach $out_file ( @PgmStderrFile ) {
147     if ( ! -f $out_file && !$SaveStderr ) {
148             print STDERR "$Pgm: warning: expected-stderr file missing: $out_file\n";
149             pop(@PgmStderrFile);
150     }
151 }
152
153 exit 1 if $Status;
154
155 # add on defaults if none specified
156 @PgmStdoutFile = ( $DefaultStdoutFile ) if $#PgmStdoutFile < 0;
157 @PgmStderrFile = ( $DefaultStderrFile ) if $#PgmStderrFile < 0;
158
159 # tidy up the pgm args:
160 # (1) look for the "first input file"
161 #     and grep it for "interesting" comments (-- !!! )
162 # (2) quote any args w/ whitespace in them.
163 $grep_done = 0;
164 foreach $a ( @PgmArgs ) {
165     if (! $grep_done && $a !~ /^-/ && -f $a) {
166         print `egrep "^--[ ]?!!!" $a`;
167         $grep_done = 1;
168     }
169     if ($a =~ /\s/ || $a =~ /'/) {
170         $a =~ s/'/\\'/g;    # backslash the quotes;
171         $a = "\"$a\"";      # quote the arg
172     }
173 }
174
175 # deal with system-specific timing options
176 $TimingMagic = '';
177 if ( $SysSpecificTiming =~ /^ghc/ ) {
178     if ($SysCPUCounting) {
179         # Count specified CPU events
180         $cpu_counting_ghc = "-a$SysCPUCounting";
181     } else {
182         $cpu_counting_ghc = "";
183     }
184     $TimingMagic = "+RTS -S$StatsFile $cpu_counting_ghc -RTS"
185 } elsif ( $SysSpecificTiming eq 'hbc' ) {
186     $TimingMagic = "-S$StatsFile";
187 }
188
189 if ($PreScript ne '') {
190     local($to_do);
191     $PreScriptLines = `cat $PreScript`;
192     $PreScriptLines =~ s/\r//g;
193 } else {
194     $PreScriptLines = '';
195 }
196
197 if ($PostScript ne '') {
198     local($to_do);
199     $PostScriptLines = `cat $PostScript`;
200     $PostScriptLines =~ s/\r//g;
201     $PostScriptLines =~ s#\$o1#$TmpPrefix/runtest$$.1#gm;
202     $PostScriptLines =~ s#\$o2#$TmpPrefix/runtest$$.2#gm;
203 # The postfix 'm' deals with recent versions of 
204 # Perl that removed the $* feature
205 } else {
206     $PostScriptLines = '';
207 }
208
209 # OK, so we're gonna do the normal thing...
210
211 if ($Cachegrind eq 'yes') {
212   $CachegrindPrefix = "valgrind --tool=cachegrind --log-fd=9 9>$CachegrindStats";
213 } else {
214   $CachegrindPrefix = '';
215 }
216
217 $Script = <<EOSCRIPT;
218 #! /bin/sh
219 myexit=0
220 diffsShown=0
221 rm -f $DefaultStdoutFile $DefaultStderrFile
222 cat /dev/null > $DefaultStdoutFile
223 cat /dev/null > $DefaultStderrFile
224 $PreScriptLines
225 $SpixifyLine1
226 $TimeCmd /bin/sh -c \'$CachegrindPrefix $ToRun $TimingMagic @PgmArgs < $PgmStdinFile 1> $TmpPrefix/runtest$$.1.raw 2> $TmpPrefix/runtest$$.2.raw 3> $TmpPrefix/runtest$$.3.raw\'
227 progexit=\$?
228 if [ "$StdoutBinary" = "0" ]; then
229     # remove Windows \r carraige-returns
230     sed 's/\r//g' < $TmpPrefix/runtest$$.1.raw > $TmpPrefix/runtest$$.1
231 else
232     cp $TmpPrefix/runtest$$.1.raw $TmpPrefix/runtest$$.1
233 fi
234 if [ "$StderrBinary" = "0" ]; then
235     # remove Windows \r carraige-returns
236     sed 's/\r//g' < $TmpPrefix/runtest$$.2.raw > $TmpPrefix/runtest$$.2
237 else
238     cp $TmpPrefix/runtest$$.2.raw $TmpPrefix/runtest$$.2
239 fi
240 sed 's/\r//g' < $TmpPrefix/runtest$$.3.raw > $TmpPrefix/runtest$$.3
241 if [ \$progexit -eq 0 ] && [ $PgmFail -ne 0 ]; then
242     echo $ToRun @PgmArgs \\< $PgmStdinFile
243     echo "****" expected a failure, but was successful
244     myexit=1
245 fi
246 if [ \$progexit -ne $PgmExitStatus ] && [ $PgmFail -eq 0 ]; then
247     echo $ToRun @PgmArgs \\< $PgmStdinFile
248     echo "****" expected exit status $PgmExitStatus not seen \\; got \$progexit
249     myexit=1
250 else
251     $PostScriptLines
252     hit='NO'
253     for out_file in @PgmStdoutFile ; do
254         if sed "s/\r\$//" $TmpPrefix/runtest$$.1 | cmp -s \$out_file - ; then
255             hit='YES'
256         fi
257     done
258     if [ \$hit = 'NO' ] ; then
259         echo $ToRun @PgmArgs \\< $PgmStdinFile
260         echo expected stdout not matched by reality
261         orig_file="$PgmStdoutFile[0]";
262         [ ! -f \$orig_file ] && orig_file="/dev/null"
263         ${CONTEXT_DIFF} \$orig_file $TmpPrefix/runtest$$.1
264         myexit=\$?
265         diffsShown=1
266     fi
267     if [ $SaveStdout = 1 ] && 
268        [ $PgmStdoutFile[0] != $DefaultStdoutFile ] && [ -s $TmpPrefix/runtest$$.1 ]; then
269         echo Saving away stdout output in $PgmStdoutFile[0] ...
270         if [ -f $PgmStdoutFile[0] ]; then
271              rm -f $PgmStdoutFile[0].bak
272              cp $PgmStdoutFile[0] $PgmStdoutFile[0].bak
273         fi;
274         cp $TmpPrefix/runtest$$.1 $PgmStdoutFile[0]
275     fi
276 fi
277
278 hit='NO'
279 for out_file in @PgmStderrFile ; do
280     if sed "s/\r\$//" $TmpPrefix/runtest$$.2 | cmp -s \$out_file - ; then
281         hit='YES'
282     fi
283 done
284 if [ \$hit = 'NO' ] ; then
285     echo $ToRun @PgmArgs \\< $PgmStdinFile
286     echo expected stderr not matched by reality
287     orig_file="$PgmStderrFile[0]"
288     [ ! -f \$orig_file ] && orig_file="/dev/null"
289     ${CONTEXT_DIFF} \$orig_file $TmpPrefix/runtest$$.2
290     myexit=\$?
291     diffsShown=1
292 fi
293 if [ $SaveStderr = 1 ] &&
294    [ $PgmStderrFile[0] != $DefaultStderrFile ] && [ -s $TmpPrefix/runtest$$.2 ]; then
295         echo Saving away stderr output in $PgmStderrFile[0] ...
296         if [ -f $PgmStderrFile[0] ]; then
297            rm -f $PgmStderrFile[0].bak
298            cp $PgmStderrFile[0] $PgmStderrFile[0].bak
299         fi;
300         cp $TmpPrefix/runtest$$.2 $PgmStderrFile[0]
301 fi
302
303 ${RM} core $ToRunOrig.spix $DefaultStdoutFile $DefaultStderrFile $TmpPrefix/runtest$$.1 $TmpPrefix/runtest$$.2 $TmpPrefix/runtest$$.3 $TmpPrefix/runtest$$.1.raw $TmpPrefix/runtest$$.2.raw $TmpPrefix/runtest$$.3.raw
304 exit \$myexit
305 EOSCRIPT
306
307 # bung script into a file
308 open(SCR, "> $ScriptFile") || die "Failed opening script file $ScriptFile!\n";
309 print SCR $Script;
310 close(SCR) || die "Failed closing script file!\n";
311 chmod 0755, $ScriptFile;
312
313 print STDERR $Script if $Verbose;
314
315 &run_something($ScriptFile);
316
317 if ( $SysSpecificTiming eq '' ) {
318     unlink $StatsFile;
319     unlink $ScriptFile;
320     exit 0;
321 }
322
323 &process_stats_file();
324 &process_cachegrind_files() if $Cachegrind eq 'yes';
325
326 # print out what we found
327 print STDERR "<<$SysSpecificTiming: ";
328 if ( $Cachegrind ne 'yes') {
329         print STDERR "$BytesAlloc bytes, $GCs GCs, $AvgResidency/$MaxResidency avg/max bytes residency ($ResidencySamples samples), $GCWork bytes GC work, ${TotMem}M in use, $InitTime INIT ($InitElapsed elapsed), $MutTime MUT ($MutElapsed elapsed), $GcTime GC ($GcElapsed elapsed), $Gc0Time GC(0) ($Gc0Elapsed elapsed), $Gc1Time GC(1) ($Gc1Elapsed elapsed), $Balance balance$Counters";
330 } else {
331         print STDERR "$BytesAlloc bytes, $GCs GCs, $AvgResidency/$MaxResidency avg/max bytes residency ($ResidencySamples samples), $GCWork bytes GC work, ${TotMem}M in use, $InitTime INIT ($InitElapsed elapsed), $MutTime MUT ($MutElapsed elapsed), $GcTime GC ($GcElapsed elapsed), $Gc0Time GC(0) ($Gc0Elapsed elapsed), $Gc1Time GC(1) ($Gc1Elapsed elapsed), $Balance balance, $TotInstrs instructions, $TotReads memory reads, $TotWrites memory writes, $TotMisses L2 cache misses";
332 };
333 print STDERR " :$SysSpecificTiming>>\n";
334
335 # OK, party over
336 unlink $StatsFile;
337 unlink $ScriptFile;
338 exit 0;
339
340 sub grab_arg_arg {
341     local($option, $rest_of_arg) = @_;
342     
343     if ($rest_of_arg ne "") {
344         return($rest_of_arg);
345     } elsif ($#ARGV >= 0) {
346         local($temp) = $ARGV[0]; shift(@ARGV); 
347         return($temp);
348     } else {
349         print STDERR "$Pgm: no argument following $option option\n";
350         $Status++;
351     }
352 }
353
354 sub run_something {
355     local($str_to_do) = @_;
356
357 #   print STDERR "$str_to_do\n" if $Verbose;
358
359     local($return_val) = 0;
360     system($str_to_do);
361     $return_val = $?;
362
363     if ($return_val != 0) {
364 #ToDo: this return-value mangling is wrong
365 #       local($die_msg) = "$Pgm: execution of the $tidy_name had trouble";
366 #       $die_msg .= " (program not found)" if $return_val == 255;
367 #       $die_msg .= " ($!)" if $Verbose && $! != 0;
368 #       $die_msg .= "\n";
369         unlink $ScriptFile;
370         unlink $StatsFile;
371
372         exit (($return_val == 0) ? 0 : 1);
373     }
374 }
375
376 sub process_stats_file {
377
378     # OK, process system-specific stats file
379     if ( $SysSpecificTiming =~ /^ghc/ ) {
380
381         #NB: nearly the same as in GHC driver's -ghc-timing stuff
382
383         open(STATS, $StatsFile) || die "Failed when opening $StatsFile\n";
384
385         local($max_live)    = 0; 
386         local($tot_live)    = 0; # for calculating residency stuff
387         local($tot_samples) = 0;
388         local($into_gc_counters) = 0; # once we reach into the GC counters part
389         local($counters) = "";
390         local($counter) = "";
391         local($count) = 0;
392
393         $GCWork = 0;
394         $GCs = 0;
395         $Balance = 1;
396         while (<STATS>) {
397             if (! /Gen:\s+0/ && /^\s*\d+\s+\d+\s+(\d+)\s+\d+\.\d+/ ) {
398                 $max_live = $1 if $max_live < $1;
399                 $tot_live += $1;
400                 $tot_samples += 1;
401             }
402
403             $BytesAlloc = $1 if /^\s*([0-9,]+) bytes allocated in the heap/;
404             
405             if (/^\s*([0-9,]+) bytes copied during GC/) {
406                $tmp = $1;
407                $tmp =~ s/,//g;
408                $GCWork += $tmp;
409             }
410
411 #           if ( /^\s*([0-9,]+) bytes maximum residency .* (\d+) sample/ ) {
412 #               $MaxResidency = $1; $ResidencySamples = $2;
413 #           }
414
415             $GCs += $1 if /^\s*Generation\s*\d+:\s*([0-9,]+) collections/;
416
417             if ( /^\s+([0-9]+)\s+M[Bb] total memory/ ) {
418                 $TotMem = $1;
419             }
420
421             if ( /^\s*INIT\s+time\s*(-*\d+\.\d\d)s\s*\(\s*(-*\d+\.\d\d)s elapsed\)/ ) {
422                 $InitTime = $1; $InitElapsed = $2;
423             } elsif ( /^\s*MUT\s+time\s*(-*\d+\.\d\d)s\s*\(\s*(-*\d+\.\d\d)s elapsed\)/ ) {
424                 $MutTime = $1; $MutElapsed = $2;
425             } elsif ( /^\s*GC\s+time\s*(-*\d+\.\d\d)s\s*\(\s*(-*\d+\.\d\d)s elapsed\)/ ) {
426                 $GcTime = $1; $GcElapsed = $2;
427             }
428
429             if (/Generation (\d+):\s*\d+ collections,\s*\d+ parallel,\s*(-*\d+\.\d\d)s\s*,\s*(-*\d+\.\d\d)s elapsed/) {
430                 if ($1 == 0) {
431                     $Gc0Time = $2; $Gc0Elapsed = $3;
432                 } elsif ($1 == 1) {
433                     $Gc1Time = $2; $Gc1Elapsed = $3;
434                 }
435             }
436
437             if (/work balance: ([0-9.]+)/) {
438                 $Balance = $1;
439             }
440
441
442             if ( /CPU GC counters/ ) {
443                 # Counters that follow correspond to GC
444                 $into_gc_counters = 1;
445             }
446
447             if ( /^\s+\(([A-Z_0-9]+)\)\s+:\s+([0-9,]+)/ ) {
448                 $counter = $1;
449                 $count   = $2;
450                 $count =~ s/,//g; # Remove commas in numbers
451                 # Pretty printing elements of a list with type [(String,[Float])]
452                 # It's a bit lame for passing values but it works.
453                 if($into_gc_counters) {
454                     $counters = "$counters(\"GC:$counter\",[$count]),";
455                 } else {
456                     $counters = "$counters(\"$counter\",[$count]),";
457                 }
458             }
459
460             if ( /^\s+\(([A-Z_0-9]+)\)\s+\%\s+of\s+\(([A-Z_0-9]+)\)\s+:\s+([0-9.]+)/ ) {
461                 $counter = "$1/$2"; # Relative quantity
462                 $count   = $3;
463                 # Pretty printing elements of a list with type [(String,[Float])]
464                 # It's a bit lame for passing values but it works.
465                 if($into_gc_counters) {
466                     $counters = "$counters(\"GC:$counter\",[$count]),";
467                 } else {
468                     $counters = "$counters(\"$counter\",[$count]),";
469                 }
470             }
471
472         }
473         close(STATS) || die "Failed when closing $StatsFile\n";
474         if ( $tot_samples > 0 ) {
475             $ResidencySamples = $tot_samples;
476             $MaxResidency = $max_live;
477             $AvgResidency = int ($tot_live / $tot_samples) ;
478         }
479
480         if ( length($counters) == 0 ) {
481             $Counters = "";
482         } else {
483             chop($counters); # remove trailing comma from the last entry
484             $Counters = " [$counters]";
485         }
486
487     } elsif ( $SysSpecificTiming eq 'hbc' ) {
488
489         open(STATS, $StatsFile) || die "Failed when opening $StatsFile\n";
490         while (<STATS>) {
491             $BytesAlloc = $1 if /^\s*([0-9]+) bytes allocated from the heap/;
492
493             $GCs = $1 if /^\s*([0-9]+) GCs?,$/;
494
495             if ( /^\s*(\d+\.\d\d) \((\d+\.\d)\) seconds total time,$/ ) {
496                 $MutTime = $1; $MutElapsed = $2; # will fix up later
497
498                 $InitTime = 0; $InitElapsed = 0; # hbc doesn't report these
499
500             } elsif ( /^\s*(\d+\.\d\d) \((\d+\.\d)\) seconds GC time/ ) {
501                 $GcTime = $1; $GcElapsed = $2;
502
503                 # fix up mutator time now
504                 $MutTime    = sprintf("%.2f", ($MutTime    - $GcTime));
505                 $MutElapsed = sprintf("%.1f", ($MutElapsed - $GcElapsed));
506             }
507         }
508         close(STATS) || die "Failed when closing $StatsFile\n";
509     }
510
511     # warn about what we didn't find
512     print STDERR "Warning: BytesAlloc not found in stats file\n" unless defined($BytesAlloc);
513     print STDERR "Warning: GCs not found in stats file\n" unless defined($GCs);
514     print STDERR "Warning: InitTime not found in stats file\n" unless defined($InitTime);
515     print STDERR "Warning: InitElapsed not found in stats file\n" unless defined($InitElapsed);
516     print STDERR "Warning: MutTime not found in stats file\n" unless defined($MutTime);
517     print STDERR "Warning: MutElapsed not found in stats file\n" unless defined($MutElapsed);
518     print STDERR "Warning: GcTime inot found in stats file\n" unless defined($GcTime);
519     print STDERR "Warning: GcElapsed not found in stats file\n" unless defined($GcElapsed);
520     print STDERR "Warning: total memory not found in stats file\n" unless defined($TotMem);
521     print STDERR "Warning: GC work not found in stats file\n" unless defined($GCWork);
522     print STDERR "Warning: Gc0Time not found in stats file\n" unless defined($Gc0Time);
523     print STDERR "Warning: Gc0Elapsed not found in stats file\n" unless defined($Gc0Elapsed);
524     print STDERR "Warning: Gc1Time not found in stats file\n" unless defined($Gc1Time);
525     print STDERR "Warning: Gc1Elapsed not found in stats file\n" unless defined($Gc1Elapsed);
526     print STDERR "Warning: Balance not found in stats file\n" unless defined($Gc1Elapsed);
527
528     # things we didn't necessarily expect to find
529     $MaxResidency     = 0 unless defined($MaxResidency);
530     $AvgResidency     = 0 unless defined($AvgResidency);
531     $ResidencySamples = 0 unless defined($ResidencySamples);
532     $Gc0Time          = 0.0 unless defined($Gc0Time);
533     $Gc0Elapsed       = 0.0 unless defined($Gc0Elapsed);
534     $Gc1Time          = 0.0 unless defined($Gc1Time);
535     $Gc1Elapsed       = 0.0 unless defined($Gc1Elapsed);
536
537     # a bit of tidying
538     $BytesAlloc =~ s/,//g;
539     $MaxResidency =~ s/,//g;
540     $GCs =~ s/,//g;
541     $InitTime =~ s/,//g;
542     $InitElapsed =~ s/,//g;
543     $MutTime =~ s/,//g;
544     $MutElapsed =~ s/,//g;
545     $GcTime =~ s/,//g;
546     $GcElapsed =~ s/,//g;
547 }
548
549 sub process_cachegrind_files {
550
551     open(STATS, "< $CachegrindStats") || die("Can't open $CachegrindStats\n");
552
553     while (<STATS>) {
554         /^==\d+==\s+I\s+refs:\s+([0-9,]*)/ && do {
555            $TotInstrs = $1;
556            $TotInstrs =~ s/,//g;
557         };
558
559         /^==\d+==\s+D\s+refs:\s+[0-9,]+\s+\(([0-9,]+)\s+rd\s+\+\s+([0-9,]+)\s+wr/ && do {
560            $TotReads  = $1;
561            $TotWrites = $2;
562            $TotReads  =~ s/,//g;
563            $TotWrites =~ s/,//g;
564         };
565
566         /^==\d+==\s+L2d\s+misses:\s+([0-9,]+)/ && do {
567            $TotMisses = $1;
568            $TotMisses =~ s/,//g;
569         };
570     }
571     close(STATS);
572 }
573